type Callback<T> = (...captures: string[]) => T;
type Rule<T> = (state: State<T>) => boolean;
type State<T> = {
    input: string;
    index: number;
    output: T[];
};
declare const rule: <T>(re: RegExp, callback: T | Callback<T>) => Rule<T>;
declare const parse: <T>(input: string, rules: Rule<T>[]) => T[];
export { rule, parse };
export type { Callback, Rule, State };
