/* MAIN */
const isFunction = (value) => {
    return typeof value === 'function';
};
const memoize = (fn) => {
    const cache = {};
    return (arg) => {
        return cache[arg] ?? (cache[arg] = fn(arg));
    };
};
const splitWith = (str, re) => {
    return [...str.matchAll(re)].map(match => match[0]);
};
/* EXPORT */
export { isFunction, memoize, splitWith };
